--basic test of AppleScript support (last modified sept 23 2011)
--uncomment lines to test

tell application "JES Deinterlacer"
	
	(* class application *)
	
	--properties
	--version
	--exists	(* always true *)
	--its file
	
	--open {POSIX file "<path1>", POSIX file "<path2>"} (* create batch of two movies *)
	
	(* class window *)
	
	windows
	--count windows
	--count (windows whose floating is true)
	--count (windows whose floating is false)
	--count (windows whose visible is false)
	--window 1
	--window 10 (*should return "object not found"*)
	--exists window 1	(* true *)
	--exists window 10	(* false *)
	--properties of window 1
	--titled of window 1	(* true - has title bar *)
	
	(*tell window "Playlists"
	end tell (*should return "no such object" if not open*) *)
	
	--make new window with properties {name:"Playlists"} (* open/activate *)
	--index of window "Playlists"
	--close window "Playlists"
	--make new window with data POSIX file "/Users/jeschot/Movies/<movie name>" 	(* open a movie for deinterlaced playback *)
	
	(* class document *)
	
	--count documents of window 3
	--properties of document 1 of window 3	(* movie played back deinterlaced, if open *)
	--file of document 1 of window 3
	
	--count documents of window "JES Deinterlacer new project dialog" (* batch waiting for OK *)
	
	(* tell window "JES Deinterlacer new project dialog"
		make new document with data POSIX file "<path>" at beginning
		(* make new document with data {POSIX file "<path1>", POSIX file "<path2>"} at end (* add files to batch *) *)
		delete document 1
		documents
	end tell *)
	
	(*if exists window "Playlists" then
		tell window "Playlists"
			if exists playlist 1 then
				tell playlist 1
					count documents
					properties of document 1
				end tell
			end if
		(* tell playlist 2
			make new document with data POSIX file "<path>" at beginning  (* add a movie at the start of the playlist *)
		end tell	*)
		end tell	(* window *)
	end if	*)
	
	(* class preset *)
	
	--count presets
	--presets
	--{preset 1, preset 2}
	--properties of preset 14
	--set name of preset id 1 to "new name"
	--setpreset with data preset 14
	--setpreset with data (name of preset 14)
	--setpreset with data "<name>"
	
	(* class playlist *)
	
	(* if not (exists window "Playlists") then
		make new window with properties {name:"Playlists"}
	end if *)
	
	(* tell window "Playlists"
		playlists
		properties of playlist 1
		count playlists
		make new playlist at end
		make new playlist at back of playlist 1
		make new playlist with data {POSIX file "<path1>", POSIX file "<path2>"} with properties {name:"My Playlist", loop:true, playing:true} at end
	end tell (* window *) *)
	
	(* class project *)
	
	--make new project (* equivalent to pressing the OK button *)
	--make new project with data preset "HD 25 -> DV progr"
	--make new project with data preset 7
	--make new project with data POSIX file "<path>" (* process file with current settings *)
	--make new project with data {POSIX file "<path1>", POSIX file "<path2>"}
	--make new project with data {preset:preset 4, file:POSIX file "<path>"}
	--make new project with data {preset:"IVT 16x9 copy snd", file:{POSIX file "<path1>", POSIX file "<path2>"}} (*process two files with preset *)
	--set suspended of project 1 to true	(* suspend project *)
	--set suspended of project 1 to false	(* resume project *)
	--delete project 1	(* cancel silently, no dialog *)
	
end tell (* application *)

tell application id "nl.jes.deinterlacer"
	(* print *)
	
	--print (* print application info *)
	--print with properties {copies:2}
	--print with print dialog
	--print window 3
	
	(* tell window "JES Deinterlacer new project dialog"
		print documents
		print (documents 2 thru 4)
	end tell *)
	--print document 1 of window 3 (* may be playback window if open *)
	
	(* if exists window "Playlists" then
		tell window "Playlists"
			print playlist 1
			print playlists
			print document 2 of playlist 2
		end tell
	end if *)
	
	--print preset 1
	--print (presets 5 thru 9)
	--print (every preset whose domain is not "app bundle")
	
	(* if exists project 1 then
		print projects
	end if *)
	
	--print (every project where it is suspended)
	
	(* move *)
	
	--move window 3 to back (* if log is open move it behind project dialog *)
	
	--move preset 2 to front
	--move {preset id 140, preset id 142} to behind preset id 143
	
	(* if exists window "Playlists" then
		tell window "Playlists"
			move playlist 2 to beginning
		end tell
	end if *)
	
	--swap two projects in the waiting queue
	(* set waiting_list to (projects whose executing is false)
	set list_count to count of waiting_list
	if (list_count > 1) then
		move item 2 of waiting_list to before item 1 of waiting_list
	end if *)
	
	--swap two movies in batch
	(* tell window "JES Deinterlacer new project dialog"
		documents
		set batch to documents
		set batch_count to count of batch
		if (batch_count > 2) then
			move item 3 of batch to before item 2 of batch
		end if
		if (batch_count > 1) then
			move item 2 of batch to front
		end if
	end tell *)
	
	--swap two movies in a playlist
	if exists window "Playlists" then
		tell window "Playlists"
			if ((count playlists) > 1) then
				if ((count documents of playlist 2) > 1) then
					move document 1 of playlist 2 to end of playlist 2
				end if
			end if
		end tell
	end if
	
	
end tell (* application *)
